/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.evaluate;

import org.fortiss.af3.exploration.model.ExplorationTarget;
import org.opt4j.core.Value;

import com.google.inject.AbstractModule;
import com.google.inject.Provides;

/**
 * Provides the evaluation value of {@link ExplorationTarget}s to the validation methods.
 * 
 * @author diewald
 */
public class ValueProvider<T extends Value<?>> extends AbstractModule {

	/** Encapsulated {@link Value}. */
	T value;

	/** {@link Value} container. Constructor. */
	public ValueProvider(T value) {
		this.value = value;
	}

	/** Returns the encapsulated {@link Value}. */
	@Provides
	public Value<?> getValue() {
		return value;
	}
}
