/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.evaluate.annotations;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.evaluate.ICompositeEvaluator;
import org.opt4j.core.problem.Evaluator;

/**
 * Utility methods for the {@link Evaluate} annotation.
 * 
 * @author diewald
 */
public class Evaluates {

	/** Prevent instantiation. */
	private Evaluates() {
	}

	/**
	 * Constructs a {@link Evaluate} annotation referencing the given {@link Evaluator}.
	 * 
	 * @param clazz
	 *            {@link Evaluator} type.
	 * @return the instantiated annotation.
	 */
	public static Evaluate eval(Class<ICompositeEvaluator<?>> clazz) {
		return new EvaluateImpl(clazz);
	}
}
