/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.crossover;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping.AbstractTaskMappingEncoding;
import org.opt4j.operators.crossover.BasicCrossoverModule;
import org.opt4j.operators.crossover.Crossover;

/**
 * Crossover module selecting the {@link CrossoverRandManyAllocation} operator to be applied on
 * {@link AbstractTaskMappingEncoding}s.
 * 
 * @author huang
 */
public class CrossoverAbstractTaskMappingModule extends BasicCrossoverModule {

	/** {@inheritDoc} */
	@SuppressWarnings("unchecked")
	@Override
	public void config() {
		super.config();

		addOperator(AbstractTaskMappingEncoding.class,
				(Class<? extends Crossover<?>>)CrossoverRandManyAllocation.class);
	}
}
