/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate.safetyarch;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.safetyfunctionarch.SafetyFunctionArchEncoding;
import org.fortiss.af3.exploration.alg.dse.sysmodel.random.RandomExploration;
import org.opt4j.core.Genotype;
import org.opt4j.operators.mutate.BasicMutateModule;
import org.opt4j.operators.mutate.Mutate;
import org.opt4j.operators.selection.RandomOperatorSelector;

import com.google.inject.Module;

/**
 * {@link Module} registering the {@link Mutate} operators within Opt4J that alter the
 * {@link SafetyFunctionArchEncoding} {@link Genotype}.
 * 
 * @author diewald
 */
public class MutateSafetyFunctionArchitectureModule extends BasicMutateModule implements Module {

	/** {@inheritDoc} */
	@Override
	public void config() {
		super.config();

		addOperatorSelectorInstance(SafetyFunctionArchEncoding.class, Mutate.class,
				new RandomOperatorSelector(RandomExploration.getInstance()));
		addOperator(SafetyFunctionArchEncoding.class, MutateChannelNumber.class);
		addOperator(SafetyFunctionArchEncoding.class, MutateSafetyTriggerSignalNumber.class);
		addOperator(SafetyFunctionArchEncoding.class, MutateConnectedDiagnosisPresent.class);
	}
}
