/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.evaluator;

import org.fortiss.af3.exploration.dsl_v2.model.expression.IExpression;
import org.fortiss.af3.exploration.lang.IExplorationExpressionVisitor;
import org.fortiss.af3.exploration.moea.model.dsmlext.FixedPropertyLiteral;

/**
 * Extended visitor for DSML elements added by the DDD-SE.
 * 
 * @author diewald
 */
public interface IExtendedExplorationExpressionVisitor extends IExplorationExpressionVisitor {

	/**
	 * Visits a {@link FixedPropertyLiteral} {@link IExpression} and returns the evaluation result.
	 * 
	 * @param fixedPropLit
	 *            Expression to evaluate.
	 * @return Evaluation result of type {@code evalType}.
	 * @throws Exception
	 *             If the {@link IExpression}'s arguments are invalid.
	 */
	Object visit(FixedPropertyLiteral<?> fixedPropLit) throws Exception;
}
