/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.exception;

import org.fortiss.af3.exploration.alg.service.IExplorationService;

/**
 * Base exception class for any exploration service.
 * 
 * @author diewald
 */
public class ExplorationServiceException extends ExplorationException {

	/**
	 * Constructs an {@link ExplorationServiceException} with information about the failed
	 * {@link IExplorationService} and the given message.
	 */
	public ExplorationServiceException(Class<? extends IExplorationService> serviceType,
			String msg) {
		super(serviceType.getSimpleName() + " failed: " + msg);
	}

	/**
	 * Constructs a {@link ExplorationServiceException} with information about the failed
	 * {@link IExplorationService} and the given message and the given {@link Exception}.
	 */
	public ExplorationServiceException(Class<? extends IExplorationService> serviceType, String msg,
			Exception e) {
		super(serviceType.getSimpleName() + " failed: " + msg, e);
	}
}
